import .connectives
import .leibniz
import .logic
axiom nat.nat : Type.
constant nat.O : nat.nat.
constant nat.S : (nat.nat) -> nat.nat.
constant nat.match_nat_type : forall (return : Type) , (return) -> ((nat.nat) -> return) -> (nat.nat) -> return.
axiom nat.axiom_match_nat_type_O : forall (return_type : Type) , forall (case_O:return_type) , forall (case_S:(nat.nat) -> return_type) , (((connectives.equal) (return_type)) (((((nat.match_nat_type) (return_type)) (case_O)) (case_S)) ((nat.O) ))) (case_O).
theorem nat.eq_match_nat_type_O : forall (return_type : Type) , forall (case_O:return_type) , forall (case_S:(nat.nat) -> return_type) , (((leibniz.leibniz) (return_type)) (((((nat.match_nat_type) (return_type)) (case_O)) (case_S)) ((nat.O) ))) (case_O) := fun (return_type : Type) , fun (case_O : return_type) , fun (case_S : (nat.nat) -> return_type) , ((((@connectives.equal_leibniz) (return_type)) (((((nat.match_nat_type) (return_type)) (case_O)) (case_S)) ((nat.O) ))) (case_O)) ((((@nat.axiom_match_nat_type_O) (return_type)) (case_O)) (case_S)).
axiom nat.axiom_match_nat_type_S : forall (return_type : Type) , forall (case_O:return_type) , forall (case_S:(nat.nat) -> return_type) , forall (n:nat.nat) , (((connectives.equal) (return_type)) (((((nat.match_nat_type) (return_type)) (case_O)) (case_S)) (((nat.S) ) (n)))) ((case_S) (n)).
theorem nat.eq_match_nat_type_S : forall (return_type : Type) , forall (case_O:return_type) , forall (case_S:(nat.nat) -> return_type) , forall (n:nat.nat) , (((leibniz.leibniz) (return_type)) (((((nat.match_nat_type) (return_type)) (case_O)) (case_S)) (((nat.S) ) (n)))) ((case_S) (n)) := fun (return_type : Type) , fun (case_O : return_type) , fun (case_S : (nat.nat) -> return_type) , fun (n : nat.nat) , ((((@connectives.equal_leibniz) (return_type)) (((((nat.match_nat_type) (return_type)) (case_O)) (case_S)) (((nat.S) ) (n)))) ((case_S) (n))) (((((@nat.axiom_match_nat_type_S) (return_type)) (case_O)) (case_S)) (n)).
theorem nat.sym_eq_match_nat_type_S : forall (return_type : Type) , forall (case_O:return_type) , forall (case_S:(nat.nat) -> return_type) , forall (n:nat.nat) , (((leibniz.leibniz) (return_type)) ((case_S) (n))) (((((nat.match_nat_type) (return_type)) (case_O)) (case_S)) (((nat.S) ) (n))) := fun (return_type : Type) , fun (case_O : return_type) , fun (case_S : (nat.nat) -> return_type) , fun (n : nat.nat) , ((((@leibniz.sym_leibniz) (return_type)) (((((nat.match_nat_type) (return_type)) (case_O)) (case_S)) (((nat.S) ) (n)))) ((case_S) (n))) (((((@nat.eq_match_nat_type_S) (return_type)) (case_O)) (case_S)) (n)).
axiom nat.nat_ind : forall (Q:(nat.nat) -> Prop) , ((Q) ((nat.O) )) -> (forall (x:nat.nat) , ((Q) (x)) -> (Q) (((nat.S) ) (x))) -> forall (x:nat.nat) , (Q) (x).
def nat.not_zero : (nat.nat) -> Prop := fun (n : nat.nat) , ((((nat.match_nat_type) (Prop)) ((connectives.False) )) (fun (p : nat.nat) , (connectives.True) )) (n).
constant nat.le_ : (nat.nat) -> (nat.nat) -> Prop.
axiom nat.le_ind : forall (n:nat.nat) , forall (Q:(nat.nat) -> Prop) , ((Q) (n)) -> (forall (m:nat.nat) , ((((nat.le_) ) (n)) (m)) -> ((Q) (m)) -> (Q) (((nat.S) ) (m))) -> forall (m:nat.nat) , ((((nat.le_) ) (n)) (m)) -> (Q) (m).
def nat.lt_ : (nat.nat) -> (nat.nat) -> Prop := fun (n : nat.nat) , fun (m : nat.nat) , (((nat.le_) ) (((nat.S) ) (n))) (m).
theorem nat.lt_to_not_zero : forall (n:nat.nat) , forall (m:nat.nat) , ((((nat.lt_) ) (n)) (m)) -> ((nat.not_zero) ) (m) := fun (n : nat.nat) , fun (m : nat.nat) , fun (Hlt : (((nat.lt_) ) (n)) (m)) , (((((((@nat.le_ind) (((nat.S) ) (n))) (fun (x_417 : nat.nat) , ((nat.not_zero) ) (x_417))) (((((((@nat.sym_eq_match_nat_type_S) (Prop)) ((connectives.False) )) (fun (p : nat.nat) , (connectives.True) )) (n)) (fun (y : Prop) , y)) (@connectives.I))) (fun (m0 : nat.nat) , fun (_x_419 : (((nat.le_) ) (((nat.S) ) (n))) (m0)) , (fun (_x_421 : ((nat.not_zero) ) (m0)) , (((((((@nat.sym_eq_match_nat_type_S) (Prop)) ((connectives.False) )) (fun (p : nat.nat) , (connectives.True) )) (m0)) (fun (y : Prop) , y)) (@connectives.I))))) (m)) (Hlt)).
theorem nat.not_le_Sn_O : forall (n:nat.nat) , ((connectives.Not) ) ((((nat.le_) ) (((nat.S) ) (n))) ((nat.O) )) := fun (n : nat.nat) , ((@connectives.nmk) ((((nat.le_) ) (((nat.S) ) (n))) ((nat.O) ))) (fun (Hlen0 : (((nat.le_) ) (((nat.S) ) (n))) ((nat.O) )) , ((((((@nat.eq_match_nat_type_O) (Prop)) ((connectives.False) )) (fun (p : nat.nat) , (connectives.True) )) (fun (y : Prop) , y)) ((((@nat.lt_to_not_zero) (n)) ((nat.O) )) (Hlen0)))).
theorem nat.lt_O_n_elim : forall (n:nat.nat) , ((((nat.lt_) ) ((nat.O) )) (n)) -> forall (P:(nat.nat) -> Prop) , (forall (m:nat.nat) , (P) (((nat.S) ) (m))) -> (P) (n) := fun (n : nat.nat) , ((((@nat.nat_ind) (fun (_x_365 : nat.nat) , ((((nat.lt_) ) ((nat.O) )) (_x_365)) -> forall (P:(nat.nat) -> Prop) , (forall (m:nat.nat) , (P) (((nat.S) ) (m))) -> (P) (_x_365))) (fun (abs : (((nat.lt_) ) ((nat.O) )) ((nat.O) )) , (((@connectives.falsity) (forall (P:(nat.nat) -> Prop) , (forall (m:nat.nat) , (P) (((nat.S) ) (m))) -> (P) ((nat.O) ))) ((((@logic.absurd) ((((nat.le_) ) (((nat.S) ) ((nat.O) ))) ((nat.O) ))) (abs)) ((@nat.not_le_Sn_O) ((nat.O) )))))) (fun (x_366 : nat.nat) , fun (_x_368 : ((((nat.lt_) ) ((nat.O) )) (x_366)) -> forall (P:(nat.nat) -> Prop) , (forall (m:nat.nat) , (P) (((nat.S) ) (m))) -> (P) (x_366)) , (fun (auto : (((nat.lt_) ) ((nat.O) )) (((nat.S) ) (x_366))) , (fun (P : (nat.nat) -> Prop) , fun (auto' : forall (m:nat.nat) , (P) (((nat.S) ) (m))) , ((auto') (x_366)))))) (n).
